<template>
    <div class="card">
       <div class="card-header">
           {{ link.name }}
       </div>
       <div class="card-body">
           <a :href="link.url"> {{ link.url }} </a>
           <p> {{ link.description }} </p>
       </div>
       <div class="card-footer">
            <button class="btn btn-warning mr-2" @click="archiveLink">
               Archiver
            </button>
           <button class="btn btn-danger mr-2" @click="deleteLink">
               Supprimer
           </button>
       </div>
    </div>
</template>

<style>

</style>

<script>
export default {
    props: {
      link: {
        type: Object,
        required: false,
        default: {}
      }
    },
    methods: {
        async archiveLink() {
            this.link.archived = true;
            try {
                        const res = await fetch('/.netlify/functions/getLinks');

                await fetch('/.netlify/functions/updateLink', {
                    method: 'PUT',
                    body: JSON.stringify(this.link)
                });
                this.$emit('refreshLinks');
            } catch (e) {
                this.$emit('refreshLinks');
                console.error(e);
            }
        },

        async deleteLink() {
            const id = this.link._id;
            try {
                await fetch('/.netlify/functions/deleteLink', {
                    method: 'DELETE',
                    body: JSON.stringify({ id })
                });
                this.$emit('refreshLinks');
            } catch (e) {
                this.$emit('refreshLinks');
                console.error(e);
            }
        }
    }
  }
</script>